<template>
    <div class="app-view-layout app-view-layout__appindexview app-index-view" v-loading="isLayoutLoadding" :style="{height: '100%', width: '100%','display': 'flex', 'flex-direction': 'column'}">
        <div v-show="!isLayoutLoadding" :style="{height: '100%', width: '100%'}">
    <app-standard-container name="container1" :isMultiContainer="false" :layoutModelDetails="layoutModelDetails">
        <template #app_apptitle>
        <app-preset-title name="app_apptitle" :layoutModelDetails="layoutModelDetails"/>
        </template>
        <template #view_pagecaption>
        <app-preset-caption name="view_pagecaption" :layoutModelDetails="layoutModelDetails"> 测试12231 </app-preset-caption>
        </template>
        <template #static_label1>
        <app-preset-text name="static_label1" :layoutModelDetails="layoutModelDetails"/>
        </template>
        <template #static_text1>
        <app-preset-text name="static_text1" :layoutModelDetails="layoutModelDetails"/>
        </template>
        <template #field_text_dynamic>
        <app-preset-text name="field_text_dynamic" :value="layoutData.field_text_dynamic" :layoutModelDetails="layoutModelDetails"/>
        </template>
        <template #field_textbox4>
        <app-panel-field name="field_textbox4" :layoutModelDetails="layoutModelDetails" :value="layoutData.field_textbox4"> <input-box type="text" name="field_textbox4" :itemValue="layoutData.field_textbox4" :disabled="layoutModelDetails.field_textbox4 ? layoutModelDetails.field_textbox4.disabled : false" @change="(value) => handleValueChange({ name: 'field_textbox4', value })"> </input-box> </app-panel-field>
        </template>
        <template #field_switch>
        <app-preset-switch name="field_switch" :layoutModelDetails="layoutModelDetails" :value="layoutData.field_switch" @valueChange="($event) => handleValueChange($event)"/>
        </template>
        <template #field_textbox>
        <app-panel-field name="field_textbox" :layoutModelDetails="layoutModelDetails" :value="layoutData.field_textbox"> <input-box type="text" name="field_textbox" :itemValue="layoutData.field_textbox" :disabled="layoutModelDetails.field_textbox ? layoutModelDetails.field_textbox.disabled : false" @change="(value) => handleValueChange({ name: 'field_textbox', value })"> </input-box> </app-panel-field>
        </template>
        <template #field_textbox1>
        <app-panel-field name="field_textbox1" :layoutModelDetails="layoutModelDetails" :value="layoutData.field_textbox1"> <dropdown-list :itemValue="layoutData.field_textbox1" :data="layoutData" :context="context" :viewparams="viewparams" :formState="viewState" :disabled="layoutModelDetails.field_textbox1 ? layoutModelDetails.field_textbox1.disabled : false" :localContext='{ }' :localParam='{ }' placeholder='请选择...' @change="(value) => handleValueChange({ name: 'field_textbox1', value })"> </dropdown-list> </app-panel-field>
        </template>
        <template #field_textbox2>
        <app-panel-field name="field_textbox2" :layoutModelDetails="layoutModelDetails" :value="layoutData.field_textbox2"> <input-box type="number" :precision="2" :itemValue="layoutData.field_textbox2" :disabled="layoutModelDetails.field_textbox2 ? layoutModelDetails.field_textbox2.disabled : false" @change="(value) => handleValueChange({ name: 'field_textbox2', value })"> </input-box> </app-panel-field>
        </template>
        <template #field_textbox3>
        <app-panel-field name="field_textbox3" :layoutModelDetails="layoutModelDetails" :value="layoutData.field_textbox3"> <input-box type="password" name="field_textbox3" :itemValue="layoutData.field_textbox3" :disabled="layoutModelDetails.field_textbox3 ? layoutModelDetails.field_textbox3.disabled : false" @change="(value) => handleValueChange({ name: 'field_textbox3', value })"> </input-box> </app-panel-field>
        </template>
        <template #field_qrcode>
        <app-preset-qrcode name="field_qrcode" :layoutModelDetails="layoutModelDetails" :value="layoutData.field_qrcode" />
        </template>
        <template #button_link1>
        <app-preset-button name="button_link1" :layoutModelDetails="layoutModelDetails" @itemClick="(name) => handleButtonClick(name)"/>
        </template>
        <template #button_openview>
        <app-preset-button name="button_openview" :layoutModelDetails="layoutModelDetails" @itemClick="(name) => handleButtonClick(name)"/>
        </template>
        <template #button_calluilogic1>
        <app-preset-button name="button_calluilogic1" :layoutModelDetails="layoutModelDetails" @itemClick="(name) => handleButtonClick(name)"/>
        </template>
        <template #button_calluilogic2>
        <app-preset-button name="button_calluilogic2" :layoutModelDetails="layoutModelDetails" @itemClick="(name) => handleButtonClick(name)"/>
        </template>
        <template #button_calluilogic3>
        <app-preset-button name="button_calluilogic3" :layoutModelDetails="layoutModelDetails" @itemClick="(name) => handleButtonClick(name)"/>
        </template>
        <template #button_calluilogic5>
        <app-preset-button name="button_calluilogic5" :layoutModelDetails="layoutModelDetails" @itemClick="(name) => handleButtonClick(name)"/>
        </template>
        <template #button_calluilogic6>
        <app-preset-button name="button_calluilogic6" :layoutModelDetails="layoutModelDetails" @itemClick="(name) => handleButtonClick(name)"/>
        </template>
        <template #button_calluilogic8>
        <app-preset-button name="button_calluilogic8" :layoutModelDetails="layoutModelDetails" @itemClick="(name) => handleButtonClick(name)"/>
        </template>
        <template #button_calluilogic9>
        <app-preset-button name="button_calluilogic9" :layoutModelDetails="layoutModelDetails" @itemClick="(name) => handleButtonClick(name)"/>
        </template>
        <template #button_calluilogic10>
        <app-preset-button name="button_calluilogic10" :layoutModelDetails="layoutModelDetails" @itemClick="(name) => handleButtonClick(name)"/>
        </template>
        <template #open_yuque>
        <app-preset-button name="open_yuque" :layoutModelDetails="layoutModelDetails" @itemClick="(name) => handleButtonClick(name)"/>
        </template>
    </app-standard-container>
        </div>
    </div>
</template>
// 基于 @VIEW/应用首页视图/VIEW-BASE.vue.ftl 生成

<script lang='tsx'>
import { Vue, Component, Prop, Provide, Emit, Watch,Inject } from 'vue-property-decorator';
import { UIActionTool, Util } from '@/utils';
import axios from 'axios';
import { AppMessageBox } from '@/utils/app-message-box/app-message-box';
import NavDataService from '@/service/app/navdata-service';
import { Subject,Subscription } from 'rxjs';


import { PanelContainerModel, PanelRawitemModel, PanelFieldModel, PanelControlModel, PanelButtonModel, PanelUserControlModel, PanelTabPanelModel, PanelTabPageModel, PanelCtrlPosModel} from '@/model/panel-detail';

import { appConfig } from '@/config/appConfig';


@Component({
    components: {
    },
})
export default class AppIndexViewBase extends Vue {
    
    /**
     * 数据变化
     *
     * @param {*} val
     * @returns {*}
     * @memberof AppIndexViewBase
     */
    @Emit() 
    public viewDatasChange(val: any):any {
        return val;
    }

    /**
     * 传入视图上下文
     *
     * @type {string}
     * @memberof AppIndexViewBase
     */
    @Prop() public viewdata!: string;

    /**
     * 传入视图参数
     *
     * @type {string}
     * @memberof AppIndexViewBase
     */
    @Prop() public viewparam!: string;

    /**
     * 视图默认使用
     *
     * @type {boolean}
     * @memberof AppIndexViewBase
     */
    @Prop({ default: true }) public viewDefaultUsage!: boolean;


	/**
	 * 视图标识
	 *
	 * @type {string}
	 * @memberof AppIndexViewBase
	 */
	public viewtag: string = '2D42F3B7-3267-4276-9120-10F2D81E35AF';

    /**
	 * 视图类型
	 *
	 * @type {string}
	 * @memberof AppIndexViewBase
	 */
	public viewType: string = 'APPINDEXVIEW';

	/**
	 * 自定义视图导航上下文集合
	 *
	 * @type {*}
	 * @memberof AppIndexViewBase
	 */
    public customViewNavContexts:any ={
    };

	/**
	 * 自定义视图导航参数集合
	 *
	 * @type {*}
	 * @memberof AppIndexViewBase
	 */
    public customViewParams:any ={
    };

    /**
     * 视图模型数据
     *
     * @type {*}
     * @memberof AppIndexViewBase
     */
    public model: any = {
        srfCaption: 'app.views.appindexview.caption',
        srfTitle: 'app.views.appindexview.title',
        srfSubTitle: 'app.views.appindexview.subtitle',
        dataInfo: ''
    }

    /**
     * 视图参数变化
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof AppIndexViewBase
     */
    @Watch('viewparam',{immediate: true, deep: true})
    onParamData(newVal: any, oldVal: any) {
        if(newVal){
            this.viewparams = {};
            if(typeof newVal == 'string') {
                Object.assign(this.viewparams, JSON.parse(this.viewparam));
            }else{
                this.viewparams = Util.deepCopy(this.viewparam);
            }
            
        } 
    }

    /**
     * 处理应用上下文变化
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof AppIndexViewBase
     */
    @Watch('viewdata')
    onViewData(newVal: any, oldVal: any) {
        const _this: any = this;
        
        if (!Object.is(newVal, oldVal) && _this.engine) {
            this.$nextTick(()=>{
              _this.parseViewParam();
              _this.engine.load();
            });
        } else if(!Object.is(newVal, oldVal) && _this.refresh && _this.refresh instanceof Function) {
            _this.refresh();
        }
    }

    /**
     * 容器模型
     *
     * @type {*}
     * @memberof AppIndexViewBase
     */
    public containerModel: any = {
        view_appmenu: { name: 'appmenu', type: 'APPMENU' },
    };

    /**
     * 视图操作参数
     *
     * @type {*}
     * @readonly
     * @memberof AppIndexViewBase
     */
    public viewCtx: any = {};

    /**
     *  计数器刷新
     *
     * @memberof AppIndexViewBase
     */
    public counterRefresh(){
        const _this:any =this;
        if(_this.counterServiceArray && _this.counterServiceArray.length >0){
            _this.counterServiceArray.forEach((item:any) =>{
                if(item.refreshData && item.refreshData instanceof Function){
                    item.refreshData();
                }
            })
        }
    }

    /**
     * 视图状态订阅对象
     *
     * @public
     * @type {Subject<{action: string, data: any}>}
     * @memberof AppIndexViewBase
     */
    public viewState: Subject<ViewState> = new Subject();

    /**
     * 视图布局顶级成员名称
     *
     * @public
     * @memberof AppIndexViewBase
     */
    public rootLayoutDetailNames: string[] = [ 'container1' ];

    /**
     * 视图布局面板项模型对象
     *
     * @public
     * @memberof AppIndexViewBase
     */
    public layoutItems:any = {
        app_apptitle:{ name: 'app_apptitle', type: 'VIEWLAYOUT', caption: '应用标题', isShowCaption: false, sysCss: '', itemType: 'FIELD', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:-1, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container1', panel: this , required: false, fieldState: '0', predefinedType: 'APP_APPTITLE', renderMode: 'HEADING1', dataItemName:'', wrapMode:'', vAlign:'', hAlign:'', },
        view_pagecaption:{ name: 'view_pagecaption', type: 'VIEWLAYOUT', caption: '页面标题', isShowCaption: false, sysCss: '', itemType: 'FIELD', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:-1, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container1', panel: this , required: false, fieldState: '0', predefinedType: 'VIEW_PAGECAPTION', renderMode: 'HEADING1', dataItemName:'', wrapMode:'', vAlign:'', hAlign:'', },
        static_label1:{ name: 'static_label1', type: 'VIEWLAYOUT', caption: '标签', isShowCaption: true, sysCss: '', itemType: 'RAWITEM', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:-1, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container1', panel: this , viewType: 'APPINDEXVIEW', predefinedType: 'STATIC_LABEL', contentType: 'RAW', contentStyle: '', rawContent: '标签测试', htmlContent: '', renderMode: 'PARAGRAPH', wrapMode:'', vAlign:'', hAlign:'', },
        static_text1:{ name: 'static_text1', type: 'VIEWLAYOUT', caption: '文本', isShowCaption: true, sysCss: '', itemType: 'RAWITEM', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:-1, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container1', panel: this , viewType: 'APPINDEXVIEW', predefinedType: 'STATIC_TEXT', contentType: 'RAW', contentStyle: '', rawContent: '文本内容测试', htmlContent: '', renderMode: 'TEXT', wrapMode:'WRAP', vAlign:'MIDDLE', hAlign:'CENTER', },
        field_text_dynamic:{ name: 'field_text_dynamic', type: 'VIEWLAYOUT', caption: '文本(动态)', isShowCaption: false, sysCss: '', itemType: 'FIELD', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:-1, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container1', panel: this , required: false, fieldState: '0', predefinedType: 'FIELD_TEXT_DYNAMIC', renderMode: 'TEXT_DYNAMIC', dataItemName:'field_textbox', wrapMode:'WRAP', vAlign:'MIDDLE', hAlign:'CENTER', },
        field_textbox4:{ name: 'field_textbox4', type: 'VIEWLAYOUT', caption: '文本框', isShowCaption: false, sysCss: '', itemType: 'FIELD', itemStyle: 'DEFAULT', visible: false, disabled: false, layout:'', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:-1, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container1', panel: this , required: false, fieldState: '0', predefinedType: 'FIELD_TEXTBOX', dataItemName:'', },
        field_switch:{ name: 'field_switch', type: 'VIEWLAYOUT', caption: '开关', isShowCaption: false, sysCss: '', itemType: 'FIELD', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:-1, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container1', panel: this , required: false, fieldState: '0', predefinedType: 'FIELD_SWITCH', dataItemName:'', },
        field_textbox:{ name: 'field_textbox', type: 'VIEWLAYOUT', caption: '文本框', isShowCaption: false, sysCss: '', itemType: 'FIELD', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:-1, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container1', panel: this , required: false, fieldState: '0', predefinedType: 'FIELD_TEXTBOX', dataItemName:'', },
        field_textbox1:{ name: 'field_textbox1', type: 'VIEWLAYOUT', caption: '文本框', isShowCaption: false, sysCss: '', itemType: 'FIELD', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:-1, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container1', panel: this , required: false, fieldState: '0', predefinedType: 'FIELD_TEXTBOX', dataItemName:'', },
        field_textbox2:{ name: 'field_textbox2', type: 'VIEWLAYOUT', caption: '文本框', isShowCaption: false, sysCss: '', itemType: 'FIELD', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:-1, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container1', panel: this , required: false, fieldState: '0', predefinedType: 'FIELD_TEXTBOX', dataItemName:'', },
        field_textbox3:{ name: 'field_textbox3', type: 'VIEWLAYOUT', caption: '文本框', isShowCaption: false, sysCss: '', itemType: 'FIELD', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:-1, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container1', panel: this , required: false, fieldState: '0', predefinedType: 'FIELD_TEXTBOX', dataItemName:'', },
        field_qrcode:{ name: 'field_qrcode', type: 'VIEWLAYOUT', caption: '二维码', isShowCaption: false, sysCss: '', itemType: 'FIELD', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:-1, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container1', panel: this , required: false, fieldState: '0', predefinedType: 'FIELD_QRCODE', dataItemName:'', },
        button_link1:{ name: 'button_link1', type: 'VIEWLAYOUT', caption: '页面链接', isShowCaption: true, sysCss: '', itemType: 'BUTTON', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:-1, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container1', panel: this , buttonStyle: 'DEFAULT', borderStyle: '', iconAlign: '', uiAction: { actiontarget: 'SINGLEDATA', noprivdisplaymode: 2, dataaccaction: '', visabled: true, disabled: false }, renderMode: 'LINK', },
        button_openview:{ name: 'button_openview', type: 'VIEWLAYOUT', caption: '打开页面', isShowCaption: true, sysCss: '', itemType: 'BUTTON', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:-1, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container1', panel: this , buttonStyle: 'DEFAULT', borderStyle: '', iconAlign: '', uiAction: { actiontarget: 'SINGLEDATA', noprivdisplaymode: 2, dataaccaction: '', visabled: true, disabled: false }, renderMode: '', },
        button_calluilogic1:{ name: 'button_calluilogic1', type: 'VIEWLAYOUT', caption: '无处理按钮', isShowCaption: true, sysCss: '', itemType: 'BUTTON', itemStyle: 'DANGER', visible: false, disabled: false, layout:'', layoutPos:'', layoutHeight:60, heightMode:'PX', layoutWidth:120, widthMode:'PX', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'CENTER', vAlignSelf:'', flexGrow:-1, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container1', panel: this , buttonStyle: 'DANGER', borderStyle: 'DASHED', iconAlign: '', renderMode: '', },
        button_calluilogic2:{ name: 'button_calluilogic2', type: 'VIEWLAYOUT', caption: '界面行为按钮', isShowCaption: true, sysCss: '', itemType: 'BUTTON', itemStyle: 'INFO', visible: true, disabled: false, layout:'', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:-1, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container1', panel: this , buttonStyle: 'INFO', borderStyle: '', iconAlign: '', uiAction: { actiontarget: 'SINGLEKEY', noprivdisplaymode: 1, dataaccaction: 'OPEN_DOCUMENT', actionDECodeName: 'IBIZBOOK', visabled: true, disabled: false }, renderMode: '', },
        button_calluilogic3:{ name: 'button_calluilogic3', type: 'VIEWLAYOUT', caption: '实体视图按钮', isShowCaption: true, sysCss: '', itemType: 'BUTTON', itemStyle: 'PRIMARY', visible: true, disabled: false, layout:'', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:-1, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container1', panel: this , buttonStyle: 'PRIMARY', borderStyle: '', iconAlign: '', uiAction: { actiontarget: 'SINGLEDATA', noprivdisplaymode: 2, dataaccaction: '', visabled: true, disabled: false }, renderMode: '', },
        button_calluilogic5:{ name: 'button_calluilogic5', type: 'VIEWLAYOUT', caption: '建立数据按钮', isShowCaption: true, sysCss: '', itemType: 'BUTTON', itemStyle: 'SUCCESS', visible: true, disabled: false, layout:'', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:-1, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container1', panel: this , buttonStyle: 'SUCCESS', borderStyle: '', iconAlign: '', uiAction: { actiontarget: '', noprivdisplaymode: 2, dataaccaction: '', visabled: true, disabled: false }, predefinedType: 'DATA_CREATEOBJECT', renderMode: '', },
        button_calluilogic6:{ name: 'button_calluilogic6', type: 'VIEWLAYOUT', caption: '保存变更按钮', isShowCaption: true, sysCss: '', itemType: 'BUTTON', itemStyle: 'WARNING', visible: true, disabled: false, layout:'', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:-1, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container1', panel: this , buttonStyle: 'WARNING', borderStyle: '', iconAlign: '', uiAction: { actiontarget: '', noprivdisplaymode: 2, dataaccaction: '', visabled: true, disabled: false }, predefinedType: 'DATA_SAVECHANGES', renderMode: '', },
        button_calluilogic8:{ name: 'button_calluilogic8', type: 'VIEWLAYOUT', caption: '删除数据按钮', isShowCaption: true, sysCss: '', itemType: 'BUTTON', itemStyle: 'PRIMARY', visible: true, disabled: false, layout:'', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:-1, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container1', panel: this , buttonStyle: 'PRIMARY', borderStyle: '', iconAlign: '', uiAction: { actiontarget: '', noprivdisplaymode: 2, dataaccaction: '', visabled: true, disabled: false }, predefinedType: 'DATA_REMOVEOBJECT', renderMode: '', },
        button_calluilogic9:{ name: 'button_calluilogic9', type: 'VIEWLAYOUT', caption: '同步数据按钮', isShowCaption: true, sysCss: '', itemType: 'BUTTON', itemStyle: 'INVERSE', visible: true, disabled: false, layout:'', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:-1, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container1', panel: this , buttonStyle: 'INVERSE', borderStyle: '', iconAlign: '', uiAction: { actiontarget: '', noprivdisplaymode: 2, dataaccaction: '', visabled: true, disabled: false }, predefinedType: 'DATA_SYNCHRONIZE', renderMode: '', },
        button_calluilogic10:{ name: 'button_calluilogic10', type: 'VIEWLAYOUT', caption: '自定义按钮', isShowCaption: true, sysCss: '', itemType: 'BUTTON', itemStyle: 'DANGER', visible: true, disabled: false, layout:'', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:-1, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container1', panel: this , buttonStyle: 'DANGER', borderStyle: '', iconAlign: '', uiAction: { actiontarget: 'NONE', noprivdisplaymode: 2, dataaccaction: '', visabled: true, disabled: false }, renderMode: '', },
        open_yuque:{ name: 'open_yuque', type: 'VIEWLAYOUT', caption: '语雀文档', isShowCaption: true, sysCss: '', itemType: 'BUTTON', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:-1, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container1', panel: this , buttonStyle: 'DEFAULT', borderStyle: '', iconAlign: '', uiAction: { actiontarget: 'SINGLEDATA', noprivdisplaymode: 2, dataaccaction: '', actionDECodeName: 'IBIZOrder', visabled: true, disabled: false }, renderMode: '', },
        container1:{ name: 'container1', type: 'VIEWLAYOUT', caption: '容器', titleBarCloseMode: 0, isShowCaption: false, sysCss: '', itemType: 'CONTAINER', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'FLEX', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:-1, flexParams:{align:'',dir:'column',vAlign:''}, panel: this , details:['app_apptitle','view_pagecaption','static_label1','static_text1','field_text_dynamic','field_textbox4','field_switch','field_textbox','field_textbox1','field_textbox2','field_textbox3','field_qrcode','button_link1','button_openview','button_calluilogic1','button_calluilogic2','button_calluilogic3','button_calluilogic5','button_calluilogic6','button_calluilogic8','button_calluilogic9','button_calluilogic10','open_yuque'] , dataRegionType: 'INHERIT' }
    }

    /**
     * 布局面板是否加载
     *
     * @public
     * @memberof AppIndexViewBase
     */
    public isLayoutLoadding: boolean = true;

    /**
     * 布局面板数据
     *
     * @public
     * @memberof AppIndexViewBase
     */
    public layoutData:any = {};

    /**
     * 布局面板模型对象
     *
     * @public
     * @memberof AppIndexViewBase
     */
    public layoutModelDetails:any = {};

    /**
     *  初始化布局
     *
     *  @public
     *  @memberof AppIndexViewBase
     */
    public async initLayout() {
        if (this.rootLayoutDetailNames.length > 0) {
            for (let i = 0; i < this.rootLayoutDetailNames.length; i++) {
                const name = this.rootLayoutDetailNames[i];
                const rootItem = this.layoutItems[name];
                if (!rootItem) {
                    return;
                }
                await this.initLayoutItem(rootItem);
            }
        }
        return true;
    }

    /**
     *  初始化布局项
     *
     *  @public
     *  @memberof AppIndexViewBase
     */
    public async initLayoutItem(layoutModelItem: any, index?: number) {
        const { name } = layoutModelItem;
        const layoutModelDetail = Util.getLayoutItemInstance(layoutModelItem);
        if (!(index || index === 0)) {
            await layoutModelDetail.load(this.context, this.viewparams);
            this.$set(this.layoutModelDetails, name, layoutModelDetail);
            this.$set(this.layoutData, name, layoutModelDetail.getData());
        } else {
            layoutModelDetail.setIndex(index);
            await layoutModelDetail.load(this.context, this.viewparams);
            this.$set(this.layoutModelDetails, `${name}_${index}`, layoutModelDetail);
            this.$set(this.layoutData, `${name}_${index}`, layoutModelDetail.getData());
        }
        if (layoutModelDetail && layoutModelDetail.details) {
            if (layoutModelDetail.dataRegionType === 'MULTIDATA') {
                const multiData = layoutModelDetail.getData();
                if (multiData && multiData.length > 0) {
                    for (let i = 0; i < multiData.length; i++) {
                        for (let j = 0; j < layoutModelDetail.details.length; j++) {
                            const key = layoutModelDetail.details[j];
                            if (this.layoutItems[key]) {
                                await this.initLayoutItem(this.layoutItems[key], i);
                            }
                        }
                    }
                }
            } else {
                for (let i = 0; i < layoutModelDetail.details.length; i++) {
                    const key = layoutModelDetail.details[i];
                    if (this.layoutItems[key]) {
                        await this.initLayoutItem(this.layoutItems[key], index);
                    }
                }
            }
        }
    }

    /**
     * 计算面板按钮权限状态
     *
     * @public
     * @memberof AppIndexViewBase
     */
    public async computeButtonAuthState() {
        for (const key in this.layoutModelDetails) {
            const layoutModel = this.layoutModelDetails[key];
            if (layoutModel.itemType == 'BUTTON') {
                await layoutModel.computeActionAuthState();
            }
        }
    }

    /**
     * 处理值改变
     *
     * @public
     * @params args 改变数据
     * @params index 多数据容器下标
     * @memberof AppIndexViewBase
     */
    public handleValueChange(args: { name: string, value: any }, index?: number) {
        const { name, value } = args;
        let fullName = (index || index === 0) ? `${name}_${index}` : name;
        if (!fullName || !this.layoutData.hasOwnProperty(fullName)) {
            return;
        }
        this.layoutData[fullName] = value;
        this.layoutModelDetails[fullName].setData(value);
        this.panelLogic(name, index);
        this.computeButtonAuthState();
    }


    /**
     * 面板逻辑
     *
     * @public
     * @params name 改变项名称
     * @params index 多数据容器下标
     * @memberof AppIndexViewBase
     */
    public panelLogic(name: string, index?: number): void {
            if (Object.is(name, '') || Object.is(name, 'field_textbox2')) {
                let ret = true;
                let _field_textbox2 = this.layoutData['field_textbox2'];
                if (index || index === 0) {
                    _field_textbox2 = this.layoutData[`field_textbox2_${index}`];
                }
                if (this.$verify.testCond(_field_textbox2, "EQ", "3")) {
                    ret = false;
                }
                if (index || index === 0) {
                    this.layoutModelDetails[`field_textbox4_${index}`].required = ret;
                } else {
                    this.layoutModelDetails['field_textbox4'].required = ret;
                }
            }
            if (Object.is(name, '') || Object.is(name, 'field_textbox2')) {
                let ret = false;
                let _field_textbox2 = this.layoutData['field_textbox2'];
                if (index || index === 0) {
                    _field_textbox2 = this.layoutData[`field_textbox2_${index}`];
                }
                if (this.$verify.testCond(_field_textbox2, "EQ", "2")) {
                    ret = true;
                }
                if (index || index === 0) {
                    this.layoutModelDetails[`field_textbox4_${index}`].disabled = !ret;
                } else {
                    this.layoutModelDetails['field_textbox4'].disabled = !ret;
                }
            }
            if (Object.is(name, '') || Object.is(name, 'field_textbox')) {
                let ret = false;
                let _field_textbox = this.layoutData['field_textbox'];
                if (index || index === 0) {
                    _field_textbox = this.layoutData[`field_textbox_${index}`];
                }
                if (this.$verify.testCond(_field_textbox, "EQ", "1")) {
                    ret = true;
                }
                if (index || index === 0) {
                    this.layoutModelDetails[`field_textbox4_${index}`].visible = ret;
                } else {
                    this.layoutModelDetails['field_textbox4'].visible = ret;
                }
            }
            if (Object.is(name, '') || Object.is(name, 'field_textbox')) {
                let ret = false;
                let _field_textbox = this.layoutData['field_textbox'];
                if (index || index === 0) {
                    _field_textbox = this.layoutData[`field_textbox_${index}`];
                }
                if (this.$verify.testCond(_field_textbox, "EQ", "1")) {
                    ret = true;
                }
                if (index || index === 0) {
                    this.layoutModelDetails[`button_calluilogic1_${index}`].visible = ret;
                } else {
                    this.layoutModelDetails['button_calluilogic1'].visible = ret;
                }
            }
    }

    /**
     * 处理按钮点击
     *
     * @public
     * @params name 按钮项名称
     * @params index 多数据容器下标
     * @memberof AppIndexViewBase
     */
    public handleButtonClick(name: string, index?: number) {
        let datas: any[] = [];
        let fullName = (index || index === 0) ? `${name}_${index}` : name;
        const data: any = this.layoutModelDetails[fullName].getData();
        if (data) {
            if (data instanceof Array) {
                datas = [...data];
            } else {
                datas = [data];
            }
        }
        const xData: any = this.layoutModelDetails[fullName].getDataArea();
        const paramJO: any = {};
        const contextJO: any = {};
        const _this: any = this;
        if (Object.is(name, 'button_link1')) {
            _this.panel_Usr1102678360_button_link1_click(datas, contextJO, paramJO, undefined, xData, this, undefined);
        }
        if (Object.is(name, 'button_openview')) {
            _this.panel_Usr1102678360_button_openview_click(datas, contextJO, paramJO, undefined, xData, this, undefined);
        }
        if (Object.is(name, 'button_calluilogic2')) {
            window.uiServiceRegister.getService('ibizbook').then((UIService: any) => {
                if (UIService && UIService[`IBIZBOOK_openDocument`] && UIService[`IBIZBOOK_openDocument`] instanceof Function) {
                    UIService[`IBIZBOOK_openDocument`](datas, contextJO, paramJO, undefined, xData, this, undefined);
                }
            })
        }
        if (Object.is(name, 'button_calluilogic3')) {
            _this.panel_Usr1102678360_button_calluilogic3_click(datas, contextJO, paramJO, undefined, xData, this, undefined);
        }
        if (Object.is(name, 'button_calluilogic5')) {
            _this.panel_Usr1102678360_button_calluilogic5_click(datas, contextJO, paramJO, undefined, xData, this, undefined);
        }
        if (Object.is(name, 'button_calluilogic6')) {
            _this.panel_Usr1102678360_button_calluilogic6_click(datas, contextJO, paramJO, undefined, xData, this, undefined);
        }
        if (Object.is(name, 'button_calluilogic8')) {
            _this.panel_Usr1102678360_button_calluilogic8_click(datas, contextJO, paramJO, undefined, xData, this, undefined);
        }
        if (Object.is(name, 'button_calluilogic9')) {
            _this.panel_Usr1102678360_button_calluilogic9_click(datas, contextJO, paramJO, undefined, xData, this, undefined);
        }
        if (Object.is(name, 'button_calluilogic10')) {
            _this.panel_Usr1102678360_button_calluilogic10_click(datas, contextJO, paramJO, undefined, xData, this, undefined);
        }
        if (Object.is(name, 'open_yuque')) {
            window.uiServiceRegister.getService('ibizorder').then((UIService: any) => {
                if (UIService && UIService[`IBIZOrder_panel_Usr1102678360_open_yuque_click`] && UIService[`IBIZOrder_panel_Usr1102678360_open_yuque_click`] instanceof Function) {
                    UIService[`IBIZOrder_panel_Usr1102678360_open_yuque_click`](datas, contextJO, paramJO, undefined, xData, this, undefined);
                }
            })
        }
    }

    /**
     * 页面链接
     *
     * @param {any[]} args 当前数据
     * @param {any} context 行为附加上下文
     * @param {*} [params] 附加参数
     * @param {*} [$event] 事件源
     * @param {*} [xData]  执行行为所需当前部件
     * @param {*} [actionContext]  执行行为上下文
     * @param {*} [srfParentDeName] 父实体名称
     * @returns {Promise<any>}
     */
    public async panel_Usr1102678360_button_link1_click(args: any[], context: any = {}, params: any={}, $event?: any, xData?: any, actionContext?: any, srfParentDeName?: string) {
        let data: any = {};
        let parentContext:any = {};
        let parentViewParam:any = {};
        const _this: any = actionContext;
        const _args: any[] = Util.deepCopy(args);
        const actionTarget: string | null = 'SINGLEDATA';
        if(_this.context){
            parentContext = _this.context;
        }
        if(_this.viewparams){
            parentViewParam = _this.viewparams;
        }
        context = UIActionTool.handleContextParam(actionTarget,_args,parentContext,parentViewParam,context);
        data = UIActionTool.handleActionParam(actionTarget,_args,parentContext,parentViewParam,params);
        context = Object.assign({},actionContext.context,context);
        let parentObj:any = {srfparentdename:srfParentDeName?srfParentDeName:null,srfparentkey:srfParentDeName?context[srfParentDeName.toLowerCase()]:null};
        Object.assign(data,parentObj);
        Object.assign(context,parentObj);
        const openPopupApp = (url: string) => {
            window.open(url, '_blank');
            return null;
        }
        const url = `https://www.baidu.com/`;
        openPopupApp(url);
    }
    /**
     * 应用视图
     *
     * @param {any[]} args 当前数据
     * @param {any} context 行为附加上下文
     * @param {*} [params] 附加参数
     * @param {*} [$event] 事件源
     * @param {*} [xData]  执行行为所需当前部件
     * @param {*} [actionContext]  执行行为上下文
     * @param {*} [srfParentDeName] 父实体名称
     * @returns {Promise<any>}
     */
    public async panel_Usr1102678360_button_openview_click(args: any[], context: any = {}, params: any={}, $event?: any, xData?: any, actionContext?: any, srfParentDeName?: string) {
        let data: any = {};
        let parentContext:any = {};
        let parentViewParam:any = {};
        const _this: any = actionContext;
        const _args: any[] = Util.deepCopy(args);
        const actionTarget: string | null = 'SINGLEDATA';
        if(_this.context){
            parentContext = _this.context;
        }
        if(_this.viewparams){
            parentViewParam = _this.viewparams;
        }
        context = UIActionTool.handleContextParam(actionTarget,_args,parentContext,parentViewParam,context);
        data = UIActionTool.handleActionParam(actionTarget,_args,parentContext,parentViewParam,params);
        context = Object.assign({},actionContext.context,context);
        let parentObj:any = {srfparentdename:srfParentDeName?srfParentDeName:null,srfparentkey:srfParentDeName?context[srfParentDeName.toLowerCase()]:null};
        Object.assign(data,parentObj);
        Object.assign(context,parentObj);
        let deResParameters: any[] = [];
        const parameters: any[] = [
            { pathName: 'ibizappviews', parameterName: 'ibizappview' },
            { pathName: 'editview', parameterName: 'editview' },
        ];
        const openIndexViewTab = (data: any) => {
            const routePath = actionContext.$viewTool.buildUpRoutePath(actionContext.$route, context, deResParameters, parameters, _args, data);
            actionContext.$router.push(routePath);
            return null;
        }
        openIndexViewTab(data);
    }
    /**
     * 应用视图
     *
     * @param {any[]} args 当前数据
     * @param {any} context 行为附加上下文
     * @param {*} [params] 附加参数
     * @param {*} [$event] 事件源
     * @param {*} [xData]  执行行为所需当前部件
     * @param {*} [actionContext]  执行行为上下文
     * @param {*} [srfParentDeName] 父实体名称
     * @returns {Promise<any>}
     */
    public async panel_Usr1102678360_button_calluilogic3_click(args: any[], context: any = {}, params: any={}, $event?: any, xData?: any, actionContext?: any, srfParentDeName?: string) {
        let data: any = {};
        let parentContext:any = {};
        let parentViewParam:any = {};
        const _this: any = actionContext;
        const _args: any[] = Util.deepCopy(args);
        const actionTarget: string | null = 'SINGLEDATA';
        if(_this.context){
            parentContext = _this.context;
        }
        if(_this.viewparams){
            parentViewParam = _this.viewparams;
        }
        context = UIActionTool.handleContextParam(actionTarget,_args,parentContext,parentViewParam,context);
        data = UIActionTool.handleActionParam(actionTarget,_args,parentContext,parentViewParam,params);
        context = Object.assign({},actionContext.context,context);
        let parentObj:any = {srfparentdename:srfParentDeName?srfParentDeName:null,srfparentkey:srfParentDeName?context[srfParentDeName.toLowerCase()]:null};
        Object.assign(data,parentObj);
        Object.assign(context,parentObj);
        let deResParameters: any[] = [];
        const parameters: any[] = [
            { pathName: 'ibizappviews', parameterName: 'ibizappview' },
            { pathName: 'listview', parameterName: 'listview' },
        ];
        const openIndexViewTab = (data: any) => {
            const routePath = actionContext.$viewTool.buildUpRoutePath(actionContext.$route, context, deResParameters, parameters, _args, data);
            actionContext.$router.push(routePath);
            return null;
        }
        openIndexViewTab(data);
    }
    /**
     * 建立数据按钮
     *
     * @param {any[]} args 当前数据
     * @param {any} context 行为附加上下文
     * @param {*} [params] 附加参数
     * @param {*} [$event] 事件源
     * @param {*} [xData]  执行行为所需当前部件
     * @param {*} [actionContext]  执行行为上下文
     * @param {*} [srfParentDeName]  父实体名称
     */
    public async panel_Usr1102678360_button_calluilogic5_click(args: any[], context: any = {}, params: any = {}, $event?: any, xData?: any, actionContext?: any, srfParentDeName?: string) {
        actionContext.$Notice.error({ title: '错误', desc: '建立数据行未配置实体' });
    }
    /**
     * 保存变更按钮
     *
     * @param {any[]} args 当前数据
     * @param {any} context 行为附加上下文
     * @param {*} [params] 附加参数
     * @param {*} [$event] 事件源
     * @param {*} [xData]  执行行为所需当前部件
     * @param {*} [actionContext]  执行行为上下文
     * @param {*} [srfParentDeName]  父实体名称
     */
    public async panel_Usr1102678360_button_calluilogic6_click(args: any[], context: any = {}, params: any = {}, $event?: any, xData?: any, actionContext?: any, srfParentDeName?: string) {
        // 选择视图保存变更
        if (Object.is(this.viewType, 'DEPICKUPVIEW') || Object.is(this.viewType, 'DEMPICKUPVIEW')) {
            this.$emit('viewdataschange', actionContext.viewSelections);
            this.$emit('close', null);
        } else {
            actionContext.$Notice.error({ title: '错误', desc: '保存变更行为未配置实体' });
        }
    }
    /**
     * 删除数据按钮
     *
     * @param {any[]} args 当前数据
     * @param {any} context 行为附加上下文
     * @param {*} [params] 附加参数
     * @param {*} [$event] 事件源
     * @param {*} [xData]  执行行为所需当前部件
     * @param {*} [actionContext]  执行行为上下文
     * @param {*} [srfParentDeName]  父实体名称
     */
    public async panel_Usr1102678360_button_calluilogic8_click(args: any[], context: any = {}, params: any = {}, $event?: any, xData?: any, actionContext?: any, srfParentDeName?: string) {
        actionContext.$Notice.error({ title: '错误', desc: '删除数据行未配置实体' });
    }
    /**
     * 同步数据按钮
     *
     * @param {any[]} args 当前数据
     * @param {any} context 行为附加上下文
     * @param {*} [params] 附加参数
     * @param {*} [$event] 事件源
     * @param {*} [xData]  执行行为所需当前部件
     * @param {*} [actionContext]  执行行为上下文
     * @param {*} [srfParentDeName]  父实体名称
     */
    public panel_Usr1102678360_button_calluilogic9_click(args: any[], context: any = {}, params: any = {}, $event?: any, xData?: any, actionContext?: any, srfParentDeName?: string) {
        if (xData) {
            if (xData.refresh && (xData.refresh instanceof Function)) {
                xData.refresh();
            } else if (xData.refreshDataArea && (xData.refreshDataArea instanceof Function)) {
                xData.refreshDataArea();
            } else {
                actionContext.$Notice.error({ title: '错误', desc: '同步数据行为未实现' });
            }
        }
    }
    /**
     * 自定义按钮
     *
     * @param {any[]} args 当前数据
     * @param {any} context 行为附加上下文
     * @param {*} [params] 附加参数
     * @param {*} [$event] 事件源
     * @param {*} [xData]  执行行为所需当前部件
     * @param {*} [actionContext]  执行行为上下文
     * @param {*} [srfParentDeName]  父实体名称
     */
    public panel_Usr1102678360_button_calluilogic10_click(args: any[], context: any = {}, params: any = {}, $event?: any, xData?: any, actionContext?: any, srfParentDeName?: string) {
        this.$Notice.error({ title: '错误', desc: '自定义行为未实现' });
    }




    /**
     * 引擎初始化
     *
     * @public
     * @memberof AppIndexViewBase
     */
    public engineInit(): void {
    }

    /**
     * 应用导航服务
     *
     * @type {*}
     * @memberof AppIndexViewBase
     */
    public  navDataService = NavDataService.getInstance();

    /**
    * 导航服务事件
    *
    * @public
    * @type {(Subscription | undefined)}
    * @memberof AppIndexViewBase
    */
    public serviceStateEvent: Subscription | undefined;

    /**
     * 门户部件状态对象
     *
     * @type {*}
     * @memberof AppIndexViewBase
     */
    @Prop() public portletState?: any;

    /**
     * 门户部件状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof AppIndexViewBase
     */
    public portletStateEvent: Subscription | undefined;

    /**
    * 门户部件状态事件
    *
    * @public
    * @type {(Subscription | undefined)}
    * @memberof AppIndexViewBase
    */
    public formDruipartEvent: Subscription | undefined;

    /**
     * 应用上下文
     *
     * @type {*}
     * @memberof AppIndexViewBase
     */
    public context:any = {};

    /**
     * 视图参数
     *
     * @type {*}
     * @memberof AppIndexViewBase
     */
    public viewparams:any = {};

    /**
     * 视图缓存数据
     *
     * @type {*}
     * @memberof AppIndexViewBase
     */
    public viewCacheData:any;


    /**
     * 计数器服务对象集合
     *
     * @type {Array<*>}
     * @memberof AppIndexViewBase
     */    
    public counterServiceArray:Array<any> = [];

    /**
     * 解析视图参数
     *
     * @public
     * @memberof AppIndexViewBase
     */
    public parseViewParam(inputvalue:any = null): void {
        for(let key in this.context){
            delete this.context[key];
        }
        if(this.$store.getters.getAppData() && this.$store.getters.getAppData().context){
            Object.assign(this.context,this.$store.getters.getAppData().context);
        }
        if (!this.viewDefaultUsage && this.viewdata && !Object.is(this.viewdata, '')) {
            if(typeof this.viewdata == 'string') {
                Object.assign(this.context, JSON.parse(this.viewdata));
            }
            if(this.context && this.context.srfparentdename){
                Object.assign(this.viewparams,{srfparentdename:this.context.srfparentdename});
            }
            if(this.context && this.context.srfparentkey){
                Object.assign(this.viewparams,{srfparentkey:this.context.srfparentkey});
            }
            this.handleCustomViewData();
            return;
        }
        const path = (this.$route.matched[this.$route.matched.length - 1]).path;
        const keys: Array<any> = [];
        const curReg = this.$pathToRegExp.pathToRegexp(path, keys);
        const matchArray = curReg.exec(this.$route.path);
        let tempValue: Object = {};
        keys.forEach((item: any, index: number) => {
            if(matchArray[index + 1]){
                Object.defineProperty(tempValue, item.name, {
                    enumerable: true,
                    value: decodeURIComponent(matchArray[index + 1])
                });
            }
        });
        this.$viewTool.formatRouteParams(tempValue,this.$route,this.context,this.viewparams);
        this.handleCustomViewData();
        //初始化导航数据
        this.initNavDataWithRoute();
    }

    /**
     * 处理自定义视图数据
     *
     * @memberof AppIndexViewBase
     */
	public handleCustomViewData(){
		if(Object.keys(this.customViewNavContexts).length > 0){
			Object.keys(this.customViewNavContexts).forEach((item:any) =>{
				let tempContext:any = {};
				let curNavContext:any = this.customViewNavContexts[item];
				this.handleCustomDataLogic(curNavContext,tempContext,item);
				Object.assign(this.context,tempContext);
			})
		}
		if(Object.keys(this.customViewParams).length > 0){
			Object.keys(this.customViewParams).forEach((item:any) =>{
				let tempParam:any = {};
				let curNavParam:any = this.customViewParams[item];
				this.handleCustomDataLogic(curNavParam,tempParam,item);
				Object.assign(this.viewparams,tempParam);
			})
		}
	}

    /**
     * 处理自定义视图数据逻辑
     *
     * @memberof AppIndexViewBase
     */
	public handleCustomDataLogic(curNavData:any,tempData:any,item:string){
		// 直接值直接赋值
		if(curNavData.isRawValue){
			if(Object.is(curNavData.value,"null") || Object.is(curNavData.value,"")){
                Object.defineProperty(tempData, item.toLowerCase(), {
                    value: null,
                    writable : true,
                    enumerable : true,
                    configurable : true
                });
            }else{
                Object.defineProperty(tempData, item.toLowerCase(), {
                    value: curNavData.value,
                    writable : true,
                    enumerable : true,
                    configurable : true
                });
            }
		}else{
			// 先从导航上下文取数，没有再从导航参数（URL）取数，如果导航上下文和导航参数都没有则为null
			if(this.context[(curNavData.value).toLowerCase()] != null){
				Object.defineProperty(tempData, item.toLowerCase(), {
					value: this.context[(curNavData.value).toLowerCase()],
					writable : true,
					enumerable : true,
					configurable : true
				});
			}else{
				if(this.viewparams[(curNavData.value).toLowerCase()] != null){
					Object.defineProperty(tempData, item.toLowerCase(), {
						value: this.viewparams[(curNavData.value).toLowerCase()],
						writable : true,
						enumerable : true,
						configurable : true
					});
				}else{
					Object.defineProperty(tempData, item.toLowerCase(), {
						value: null,
						writable : true,
						enumerable : true,
						configurable : true
					});
				}
			}
		}
	}

    /**
     * 初始化导航数据(路由模式)
     *
     * @memberof AppIndexViewBase
     */
    public initNavDataWithRoute(data:any = null, isNew:boolean = false,  isAlways:boolean = false){
        if( isAlways || (this.viewDefaultUsage && Object.is(this.navModel,"route")) ){
            this.navDataService.addNavData({id:'app-index-view',tag:this.viewtag,srfkey:isNew ? null : null,title:this.$t(this.model.srfCaption),data:data,context:this.context,viewparams:this.viewparams,path:this.$route.fullPath});
        }
    }

    /**
     * 初始化导航数据(分页模式)
     *
     * @memberof AppIndexViewBase
     */
    public initNavDataWithTab(data:any = null,isOnlyAdd:boolean = true, isAlways:boolean = false){
        if( isAlways || (this.viewDefaultUsage && !Object.is(this.navModel,"route")) ){
            this.navDataService.addNavDataByOnly({id:'app-index-view',tag:this.viewtag,srfkey:null,title:this.$t(this.model.srfCaption),data:data,context:this.context,viewparams:this.viewparams,path:this.$route.fullPath},isOnlyAdd);
        }
    }
	

    /**
     * Vue声明周期
     *
     * @memberof AppIndexViewBase
     */
    public created() {
        this.afterCreated();
    }

    /**
     * 执行created后的逻辑
     *
     * @memberof AppIndexViewBase
     */    
    public afterCreated(){
        let _this:any = this;
        const secondtag = _this.$util.createUUID();
        _this.$store.commit('viewaction/createdView', { viewtag: _this.viewtag, secondtag: secondtag });
        _this.viewtag = secondtag;
        _this.parseViewParam();
        _this.serviceStateEvent = _this.navDataService.serviceState.subscribe(({ action,name, data }:{ action:string,name:any,data:any }) => {
            if(!Object.is(name,'app-index-view')){
                return;
            }
            if (Object.is(action, 'viewrefresh')) {
                _this.$nextTick(()=>{
                    _this.parseViewParam(data);
                    if(_this.engine){
                        _this.engine.load();
                    }
                }); 
            }
        });
        if(_this.portletState){
            _this.portletStateEvent = _this.portletState.subscribe((res:any) =>{
                if(!Object.is(res.name,'AppIndexView')){
                    return;
                }
                if(Object.is(res.action,'refresh') && _this.refresh && _this.refresh instanceof Function){
                    _this.refresh();
                }
            })
        }
        _this.initViewCtx();
    }

    /**
     * 初始化视图操作参数
     *
     * @memberof AppIndexViewBase
     */  
    initViewCtx() {
        Object.assign(this.viewCtx, {
            app: this.$root,
            view: this,
            viewGlobal: {},
            viewNavData: {},
            viewNavContext: this.context,
            viewNavParam: this.viewparams,
            messagebox: AppMessageBox.getInstance(),
        });
        Object.assign(this.viewCtx, { appGlobal: this.$store.getters.getAppGlobal() });
        if (this.$store.getters.getRouteViewGlobal(this.context.srfsessionid)) {
            Object.assign(this.viewCtx, { routeViewGlobal: this.$store.getters.getRouteViewGlobal(this.context.srfsessionid) });
        } else {
            this.$store.commit('addRouteViewGlobal', { tag: this.context.srfsessionid, param: {} });
            Object.assign(this.viewCtx, { routeViewGlobal: this.$store.getters.getRouteViewGlobal(this.context.srfsessionid) });
        }
        if (!this.viewDefaultUsage && this.viewdata && !Object.is(this.viewdata, '')) {
            //  嵌入视图
            Object.assign(this.viewCtx, {
                topview: this.$store.getters.getView(this.context.srfsessionid)
            });
        } else {
            //  顶层视图
            this.$store.commit('addView', { tag: this.context.srfsessionid, param: this });
            Object.assign(this.viewCtx, { topview: this });
        }
    }

    /**
     * 销毁之前
     *
     * @memberof AppIndexViewBase
     */
    public beforeDestroy() {
        this.$store.commit('viewaction/removeView', this.viewtag);

        let _this: any = this
        if (_this.serviceStateEvent) {
            _this.serviceStateEvent.unsubscribe();
        }
        if (_this.portletStateEvent) {
            _this.portletStateEvent.unsubscribe();
        }
        if (_this.formDruipartEvent) {
            _this.formDruipartEvent.unsubscribe();
        }
        if (_this.engine) {
            _this.engine.destroy();
        }
    }

    /**
     * Vue声明周期(组件初始化完毕)
     *
     * @memberof AppIndexViewBase
     */
    public mounted() {
        this.afterMounted();
    }

    /**
     * 执行mounted后的逻辑
     * 
     * @memberof AppIndexViewBase
     */
    public afterMounted(){
        const _this: any = this;
        _this.initLayout().then((result: any) => {
            _this.isLayoutLoadding = false;
            _this.engineInit();
            if (_this.loadModel && _this.loadModel instanceof Function) {
                _this.loadModel();
            }
                    this.viewState.next({ tag: 'appmenu', action: 'load', data: {} });
            this.$viewTool.setIndexParameters([{ pathName: 'appindexview', parameterName: 'appindexview' }]);
            this.$viewTool.setIndexViewParam(this.context);
            this.mouse_move();
        })
    }




    /**
     * 关闭视图
     *
     * @param {any[]} args
     * @memberof AppIndexViewBase
     */
    public closeView(args: any[]): void {
        let _view: any = this;
        if (_view.viewdata) {
            _view.$emit('viewdataschange', Array.isArray(args)?args:[args]);
            _view.$emit('close', Array.isArray(args)?args:[args]);
        } else if (_view.$tabPageExp) {
            _view.$tabPageExp.onClose(_view.$route.fullPath);
        }else{
            _view.$router.back();
        }
    }

    /**
     * 菜单位置
     *
     * @public
     * @type {string}
     * @memberof AppIndexViewBase
     */
    public mode: string ='vertical';

    /**
     * 导航模式(route:面包屑模式、tab:分页导航模式)
     *
     * @type {string}
     * @memberof AppIndexViewBase
     */
    @Provide()
    public navModel:string = "tab";

    /**
     * 抽屉状态
     *
     * @type {boolean}
     * @memberof AppIndexViewBase
     */
    public contextMenuDragVisiable: boolean = false;

    /**
     * 是否支持应用切换
     *
     * @type {boolean}
     * @memberof AppIndexViewBase
     */
    public isEnableAppSwitch: boolean = false;

    /**
     * 初始化之前
     *
     * @memberof AppIndexViewBase
     */
    public beforeCreate(){
        let navDataService = NavDataService.getInstance();
        navDataService.removeAllNavData();
    }

    /**
     * 当前主题
     *
     * @readonly
     * @memberof AppIndexViewBase
     */
    get selectTheme() {
        if (this.$router.app.$store.state.selectTheme) {
            return this.$router.app.$store.state.selectTheme;
        } else if (localStorage.getItem('theme-class')) {
            return localStorage.getItem('theme-class');
        } else {
            return appConfig.defaultTheme;
        }
    }

    /**
     * 当前字体
     *
     * @readonly
     * @memberof AppIndexViewBase
     */
    get selectFont() {
        if (this.$router.app.$store.state.selectFont) {
            return this.$router.app.$store.state.selectFont;
        } else if (localStorage.getItem('font-family')) {
            return localStorage.getItem('font-family');
        } else {
            return appConfig.defaultFont;
        }
    }

    /**
     * 菜单收缩变化
     *
     * @type {boolean}
     * @memberof AppIndexViewBase
     */
    public collapseChange: boolean = false;

    /**
     * 菜单收缩点击
     *
     * @memberof AppIndexViewBase
     */
    public handleClick(): void {
        this.collapseChange = !this.collapseChange;
    }

    /**
     * 默认打开的视图
     *
     * @type {*}
     * @memberof AppIndexViewBase
     */
    public defPSAppView: any = {
    };

    /**
     * 应用起始页面
     *
     * @type {boolean}
     * @memberof AppIndexViewBase
     */
    public isDefaultPage: boolean = false;

    /**
     * 空白视图模式
     *
     * @type {boolean}
     * @memberof AppIndexViewBase
     */
    public isBlankMode:boolean = false;

    /**
     * 获取样式
     *
     * @readonly
     * @type {string[]}
     * @memberof AppIndexViewBase
     */
    get themeClasses(): string {
        return this.selectTheme;
    }

    /**
     * 主题字体
     *
     * @readonly
     * @type {*}
     * @memberof AppIndexViewBase
     */
    get themeStyle(): any {
        return {
            'height': '100vh',
            'font-family': this.selectFont,
        }
    }

    /**
     * 获取路由列表
     *
     * @readonly
     * @type {any[]}
     * @memberof AppIndexViewBase
     */
    get getRouterList(): any[] {
        return this.$store.state.historyPathList;
    }

    /**
     * 获取路由键值
     *
     * @readonly
     * @type {string}
     * @memberof AppIndexViewBase
     */
    get getRouterViewKey(): string {
        return this.$route.fullPath;
    }

    /**
     * 鼠标拖动事件
     *
     * @param {*} val
     * @returns {*}
     * @memberof AppIndexViewBase
     */
    public mouse_move(){
        let move_axis:any = document.getElementById("move_axis");
        let left_move :any= document.getElementById("left_move");
        let right_move :any= document.getElementById("right_move");
        let movebox :any= document.getElementById("movebox");
        if(left_move && right_move && move_axis && movebox){
            let leftWidth :number = parseInt(left_move.style.width);
            move_axis.onmousedown = (e:any) =>{
                let startX = e.clientX;
                move_axis.left = move_axis.offsetLeft;
                document.onmousemove =  (e:any) =>{
                    let endX = e.clientX; 
                    let moveLen = move_axis.left + (endX - startX);
                    let maxT = movebox.clientWidth - move_axis.offsetWidth;
                    if (moveLen < 150) moveLen = 150;
                    if (moveLen > maxT - 150) moveLen = maxT - 150; 
                    move_axis.style.left = moveLen;
                    left_move.style.width = moveLen + "px";
                    right_move.style.width = (movebox.clientWidth - moveLen - 5) + "px";
                    if (moveLen>500) {
                        left_move.style.width = 500 + 'px';
                    }

                    let left_width : number = parseInt(left_move.style.width);
                    move_axis.style.left = left_width - 5 + 'px';
                    if (left_width < leftWidth){
                        move_axis.style.left = leftWidth - 5 + 'px';
                    }
                }
                document.onmouseup = (evt) =>{
                    document.onmousemove = null;
                    document.onmouseup = null;
                    move_axis.releaseCapture && move_axis.releaseCapture();
                }
                move_axis.setCapture && move_axis.setCapture();
                return false;
            }
        }
    }

}
</script>

<style lang='scss'>
@import './app-index-view.scss';
</style>